VTK: vtkUnstructuredGridPreIntegration Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkUnstructuredGridPreIntegration Class Reference

performs ray integration with pre-integration tables. More...

`#include <vtkUnstructuredGridPreIntegration.h>`

Inheritance diagram for vtkUnstructuredGridPreIntegration:
[legend]
Collaboration diagram for vtkUnstructuredGridPreIntegration:
[legend]

## Public Types
typedef vtkUnstructuredGridVolumeRayIntegrator | Superclass
Public Types inherited from vtkUnstructuredGridVolumeRayIntegrator
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkUnstructuredGridPreIntegration * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Initialize (vtkVolume *volume, vtkDataArray *scalars) override
| Set up the integrator with the given properties and scalars. More...
void | Integrate (vtkDoubleArray *intersectionLengths, vtkDataArray *nearIntersections, vtkDataArray *farIntersections, float color[4]) override
| Given a set of intersections (defined by the three arrays), compute the piecewise integration of the array in front to back order. More...
virtual float * | GetPreIntegrationTable (int component=0)
| Get the partial pre-integration table for the given scalar component. More...
float * | GetTableEntry (double scalar_front, double scalar_back, double length, int component=0)
| Get an entry (RGBA) in one of the pre-integration tables. More...
float * | GetIndexedTableEntry (int scalar_front_index, int scalar_back_index, int length_index, int component=0)
| Like GetTableEntry, except the inputs are scaled indices into the table rather than than the actual scalar and length values. More...
virtual vtkUnstructuredGridVolumeRayIntegrator * | GetIntegrator ()
| The class used to fill the pre integration table. More...
virtual void | SetIntegrator (vtkUnstructuredGridVolumeRayIntegrator *)
| The class used to fill the pre integration table. More...
virtual void | SetIntegrationTableScalarResolution (int)
| Set/Get the size of the integration table built. More...
virtual int | GetIntegrationTableScalarResolution ()
| Set/Get the size of the integration table built. More...
virtual void | SetIntegrationTableLengthResolution (int)
| Set/Get the size of the integration table built. More...
virtual int | GetIntegrationTableLengthResolution ()
| Set/Get the size of the integration table built. More...
virtual double | GetIntegrationTableScalarShift (int component=0)
| Get how an integration table is indexed. More...
virtual double | GetIntegrationTableScalarScale (int component=0)
| Get how an integration table is indexed. More...
virtual double | GetIntegrationTableLengthScale ()
| Get how an integration table is indexed. More...
virtual vtkTypeBool | GetIncrementalPreIntegration ()
| Get/set whether to use incremental pre-integration (by default it's on). More...
virtual void | SetIncrementalPreIntegration (vtkTypeBool)
| Get/set whether to use incremental pre-integration (by default it's on). More...
virtual void | IncrementalPreIntegrationOn ()
| Get/set whether to use incremental pre-integration (by default it's on). More...
virtual void | IncrementalPreIntegrationOff ()
| Get/set whether to use incremental pre-integration (by default it's on). More...
Public Member Functions inherited from vtkUnstructuredGridVolumeRayIntegrator
vtkUnstructuredGridVolumeRayIntegrator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkUnstructuredGridPreIntegration * | SafeDownCast (vtkObjectBase *o)
static vtkUnstructuredGridPreIntegration * | New ()
Static Public Member Functions inherited from vtkUnstructuredGridVolumeRayIntegrator
static vtkTypeBool | IsTypeOf (const char *type)
static vtkUnstructuredGridVolumeRayIntegrator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkUnstructuredGridPreIntegration ()
| ~vtkUnstructuredGridPreIntegration () override
virtual void | BuildPreIntegrationTables (vtkDataArray *scalars)
Protected Member Functions inherited from vtkUnstructuredGridVolumeRayIntegrator
| vtkUnstructuredGridVolumeRayIntegrator ()
| ~vtkUnstructuredGridVolumeRayIntegrator () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkUnstructuredGridVolumeRayIntegrator * | Integrator
vtkVolume * | Volume
vtkVolumeProperty * | Property
double | MaxLength
int | NumComponents
float ** | IntegrationTable
double * | IntegrationTableScalarShift
double * | IntegrationTableScalarScale
double | IntegrationTableLengthScale
vtkTimeStamp | IntegrationTableBuilt
int | IntegrationTableScalarResolution
int | IntegrationTableLengthResolution
vtkTypeBool | IncrementalPreIntegration
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

performs ray integration with pre-integration tables.

vtkUnstructuredGridPreIntegration performs ray integration by looking into a precomputed table. The result should be equivalent to that computed by vtkUnstructuredGridLinearRayIntegrator and vtkUnstructuredGridPartialPreIntegration, but faster than either one. The pre-integration algorithm was first introduced by Roettger, Kraus, and Ertl in "Hardware-Accelerated Volume And Isosurface Rendering Based On Cell-Projection."

Due to table size limitations, a table can only be indexed by independent scalars. Thus, dependent scalars are not supported.

Definition at line 33 of file vtkUnstructuredGridPreIntegration.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkUnstructuredGridVolumeRayIntegrator vtkUnstructuredGridPreIntegration::Superclass

Definition at line 37 of file vtkUnstructuredGridPreIntegration.h.

## Constructor & Destructor Documentation

## ◆ vtkUnstructuredGridPreIntegration()

vtkUnstructuredGridPreIntegration::vtkUnstructuredGridPreIntegration | ( |  | ) |
| protected

## ◆ ~vtkUnstructuredGridPreIntegration()

vtkUnstructuredGridPreIntegration::~vtkUnstructuredGridPreIntegration | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkUnstructuredGridPreIntegration::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkUnstructuredGridPreIntegration::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkUnstructuredGridVolumeRayIntegrator.

## ◆ SafeDownCast()

static vtkUnstructuredGridPreIntegration* vtkUnstructuredGridPreIntegration::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkUnstructuredGridPreIntegration::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkUnstructuredGridVolumeRayIntegrator.

## ◆ NewInstance()

vtkUnstructuredGridPreIntegration* vtkUnstructuredGridPreIntegration::NewInstance | ( |  | ) | const

## ◆ New()

static vtkUnstructuredGridPreIntegration* vtkUnstructuredGridPreIntegration::New | ( |  | ) |
| static

## ◆ PrintSelf()

void vtkUnstructuredGridPreIntegration::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Initialize()

void vtkUnstructuredGridPreIntegration::Initialize | ( | vtkVolume * | volume,
|  | vtkDataArray * | scalars
| ) |  |
| overridevirtual

Set up the integrator with the given properties and scalars.

Implements vtkUnstructuredGridVolumeRayIntegrator.

## ◆ Integrate()

void vtkUnstructuredGridPreIntegration::Integrate | ( | vtkDoubleArray * | intersectionLengths,
|  | vtkDataArray * | nearIntersections,
|  | vtkDataArray * | farIntersections,
|  | float | color[4]
| ) |  |
| overridevirtual

Given a set of intersections (defined by the three arrays), compute the piecewise integration of the array in front to back order.

/c intersectionLengths holds the lengths of each piecewise segment. /c nearIntersections and /c farIntersections hold the scalar values at the front and back of each segment. /c color should contain the RGBA value of the volume in front of the segments passed in, and the result will be placed back into /c color.

Implements vtkUnstructuredGridVolumeRayIntegrator.

## ◆ GetIntegrator()

virtual vtkUnstructuredGridVolumeRayIntegrator* vtkUnstructuredGridPreIntegration::GetIntegrator | ( |  | ) |
| virtual

The class used to fill the pre integration table.

By default, a vtkUnstructuredGridPartialPreIntegration is built.

## ◆ SetIntegrator()

virtual void vtkUnstructuredGridPreIntegration::SetIntegrator | ( | vtkUnstructuredGridVolumeRayIntegrator * |  | ) |
| virtual

The class used to fill the pre integration table.

By default, a vtkUnstructuredGridPartialPreIntegration is built.

## ◆ SetIntegrationTableScalarResolution()

virtual void vtkUnstructuredGridPreIntegration::SetIntegrationTableScalarResolution | ( | int |  | ) |
| virtual

Set/Get the size of the integration table built.

## ◆ GetIntegrationTableScalarResolution()

virtual int vtkUnstructuredGridPreIntegration::GetIntegrationTableScalarResolution | ( |  | ) |
| virtual

Set/Get the size of the integration table built.

## ◆ SetIntegrationTableLengthResolution()

virtual void vtkUnstructuredGridPreIntegration::SetIntegrationTableLengthResolution | ( | int |  | ) |
| virtual

Set/Get the size of the integration table built.

## ◆ GetIntegrationTableLengthResolution()

virtual int vtkUnstructuredGridPreIntegration::GetIntegrationTableLengthResolution | ( |  | ) |
| virtual

Set/Get the size of the integration table built.

## ◆ GetIntegrationTableScalarShift()

virtual double vtkUnstructuredGridPreIntegration::GetIntegrationTableScalarShift | ( | int | component = `0` | ) |
| virtual

Get how an integration table is indexed.

## ◆ GetIntegrationTableScalarScale()

virtual double vtkUnstructuredGridPreIntegration::GetIntegrationTableScalarScale | ( | int | component = `0` | ) |
| virtual

Get how an integration table is indexed.

## ◆ GetIntegrationTableLengthScale()

virtual double vtkUnstructuredGridPreIntegration::GetIntegrationTableLengthScale | ( |  | ) |
| virtual

Get how an integration table is indexed.

## ◆ GetIncrementalPreIntegration()

virtual vtkTypeBool vtkUnstructuredGridPreIntegration::GetIncrementalPreIntegration | ( |  | ) |
| virtual

Get/set whether to use incremental pre-integration (by default it's on).

Incremental pre-integration is much faster but can introduce error due to numerical imprecision. Under most circumstances, the error is not noticeable.

## ◆ SetIncrementalPreIntegration()

virtual void vtkUnstructuredGridPreIntegration::SetIncrementalPreIntegration | ( | vtkTypeBool |  | ) |
| virtual

Get/set whether to use incremental pre-integration (by default it's on).

Incremental pre-integration is much faster but can introduce error due to numerical imprecision. Under most circumstances, the error is not noticeable.

## ◆ IncrementalPreIntegrationOn()

virtual void vtkUnstructuredGridPreIntegration::IncrementalPreIntegrationOn | ( |  | ) |
| virtual

Get/set whether to use incremental pre-integration (by default it's on).

Incremental pre-integration is much faster but can introduce error due to numerical imprecision. Under most circumstances, the error is not noticeable.

## ◆ IncrementalPreIntegrationOff()

virtual void vtkUnstructuredGridPreIntegration::IncrementalPreIntegrationOff | ( |  | ) |
| virtual

Get/set whether to use incremental pre-integration (by default it's on).

Incremental pre-integration is much faster but can introduce error due to numerical imprecision. Under most circumstances, the error is not noticeable.

## ◆ GetPreIntegrationTable()

virtual float* vtkUnstructuredGridPreIntegration::GetPreIntegrationTable | ( | int | component = `0` | ) |
| virtual

Get the partial pre-integration table for the given scalar component.

The tables are built when Initialize is called. A segment of length d with a front scalar of sf and a back scalar of sb is referenced in the resulting table as 4 * ((l * `IntegrationTableLengthScale`) * `IntegrationTableScalarResolution` * `IntegrationTableScalarResolution`

- (sb * `IntegrationTableScalarScale` + `IntegrationTableScalarShift`) * `IntegrationTableScalarResolution`
- (sf * `IntegrationTableScalarScale` + `IntegrationTableScalarShift`)).

## ◆ GetTableEntry()

float * vtkUnstructuredGridPreIntegration::GetTableEntry | ( | double | scalar_front,
|  | double | scalar_back,
|  | double | length,
|  | int | component = `0`
| ) |  |
| inline

Get an entry (RGBA) in one of the pre-integration tables.

The tables are built when Initialize is called.

Definition at line 168 of file vtkUnstructuredGridPreIntegration.h.

## ◆ GetIndexedTableEntry()

float * vtkUnstructuredGridPreIntegration::GetIndexedTableEntry | ( | int | scalar_front_index,
|  | int | scalar_back_index,
|  | int | length_index,
|  | int | component = `0`
| ) |  |
| inline

Like GetTableEntry, except the inputs are scaled indices into the table rather than than the actual scalar and length values.

Use GetTableEntry unless you are really sure you know what you are doing.

Definition at line 142 of file vtkUnstructuredGridPreIntegration.h.

## ◆ BuildPreIntegrationTables()

virtual void vtkUnstructuredGridPreIntegration::BuildPreIntegrationTables | ( | vtkDataArray * | scalars | ) |
| protectedvirtual

## Member Data Documentation

## ◆ Integrator

vtkUnstructuredGridVolumeRayIntegrator* vtkUnstructuredGridPreIntegration::Integrator
| protected

Definition at line 117 of file vtkUnstructuredGridPreIntegration.h.

## ◆ Volume

vtkVolume* vtkUnstructuredGridPreIntegration::Volume
| protected

Definition at line 119 of file vtkUnstructuredGridPreIntegration.h.

## ◆ Property

vtkVolumeProperty* vtkUnstructuredGridPreIntegration::Property
| protected

Definition at line 120 of file vtkUnstructuredGridPreIntegration.h.

## ◆ MaxLength

double vtkUnstructuredGridPreIntegration::MaxLength
| protected

Definition at line 121 of file vtkUnstructuredGridPreIntegration.h.

## ◆ NumComponents

int vtkUnstructuredGridPreIntegration::NumComponents
| protected

Definition at line 123 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IntegrationTable

float** vtkUnstructuredGridPreIntegration::IntegrationTable
| protected

Definition at line 124 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IntegrationTableScalarShift

double* vtkUnstructuredGridPreIntegration::IntegrationTableScalarShift
| protected

Definition at line 125 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IntegrationTableScalarScale

double* vtkUnstructuredGridPreIntegration::IntegrationTableScalarScale
| protected

Definition at line 126 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IntegrationTableLengthScale

double vtkUnstructuredGridPreIntegration::IntegrationTableLengthScale
| protected

Definition at line 127 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IntegrationTableBuilt

vtkTimeStamp vtkUnstructuredGridPreIntegration::IntegrationTableBuilt
| protected

Definition at line 128 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IntegrationTableScalarResolution

int vtkUnstructuredGridPreIntegration::IntegrationTableScalarResolution
| protected

Definition at line 130 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IntegrationTableLengthResolution

int vtkUnstructuredGridPreIntegration::IntegrationTableLengthResolution
| protected

Definition at line 131 of file vtkUnstructuredGridPreIntegration.h.

## ◆ IncrementalPreIntegration

vtkTypeBool vtkUnstructuredGridPreIntegration::IncrementalPreIntegration
| protected

Definition at line 133 of file vtkUnstructuredGridPreIntegration.h.

The documentation for this class was generated from the following file:

- Rendering/Volume/vtkUnstructuredGridPreIntegration.h